BulkyWeb/Areas/Admin/Controllers/OrderController.cs
using Microsoft.AspNetCore.Mvc;
using Bulky.Models;
using Bulky.Models.ViewModels;
using Bulky.DataAccess.Repository.IRepository;
using System.Security.Claims;
using Stripe;
using Stripe.Checkout;
using Microsoft.AspNetCore.Authorization;
using Bulky.Utils;

namespace BulkyWeb.Areas.Admin.Controllers;

[Area("Admin")]
// [Authorize]
public class OrderController : Controller
{


    private readonly IUnitOfWork _unitOfWork;

    [BindProperty]
    public OrderVM? orderVM { get; set; }

    public OrderController(IUnitOfWork unitOfWork)
    {
        _unitOfWork = unitOfWork;
    }


    public IActionResult Index()
    {
        return View();
    }


    public IActionResult Details(int orderId)
    {
        orderVM = new ()
        {
            OrderHeader = _unitOfWork.OrderHeader.Get(o => o.Id == orderId, includeProperties:"ApplicationUser"),
            OOrderDetailList = _unitOfWork.OrderDetail.GetAll(d => d.OrderHeaderId == orderId, includeProperties:"BookProduct")
        };
        return View(orderVM);
    }

    [Authorize(Roles = SD.Role_Admin + "," + SD.Role_Employee)]
    [HttpPost]
    public IActionResult UpdateOrderDetails()
    {
        OrderHeader outputOrderHeader = new OrderHeader();

        if (orderVM?.OrderHeader is not null)
        {
            var oh = _unitOfWork.OrderHeader.Get(o => o.Id == orderVM.OrderHeader.Id);
            oh.Name = orderVM.OrderHeader.Name;
            oh.PhoneNumber = orderVM.OrderHeader.PhoneNumber;
            oh.StreetAddress = orderVM.OrderHeader.StreetAddress;
            oh.City = orderVM.OrderHeader.City;
            oh.State = orderVM.OrderHeader.State;
            oh.PostalCode = orderVM.OrderHeader.PostalCode;

            if (!String.IsNullOrEmpty(orderVM.OrderHeader.Carrier))
            {
                oh.Carrier = orderVM.OrderHeader.Carrier;
            }

            if (!String.IsNullOrEmpty(orderVM.OrderHeader.TrackingNumber))
            {
                oh.Carrier = orderVM.OrderHeader.TrackingNumber;
            }
            outputOrderHeader = oh;
            _unitOfWork.OrderHeader.Update(outputOrderHeader);
            _unitOfWork.Save();

            TempData["Success"] = "Order Details Updated Successfully";

        }

        return RedirectToAction(nameof(Details), new { orderId = outputOrderHeader.Id });

    }

    [ActionName("Details")]
    [HttpPost]
    public IActionResult Details_PAY_NOW()
    {

        if (orderVM?.OrderHeader is not null)
        {
            orderVM.OrderHeader = _unitOfWork.OrderHeader
                .Get(u => u.Id == orderVM.OrderHeader.Id, includeProperties: "ApplicationUser");
            orderVM.OOrderDetailList = _unitOfWork.OrderDetail
                .GetAll(u => u.OrderHeaderId == orderVM.OrderHeader.Id, includeProperties: "Product");

            //stripe logic
            var domain = Request.Scheme + "://" + Request.Host.Value + "/";
            var options = new SessionCreateOptions {
                SuccessUrl = domain + $"admin/order/PaymentConfirmation?orderHeaderId={orderVM.OrderHeader.Id}",
                CancelUrl = domain + $"admin/order/details?orderId={orderVM.OrderHeader.Id}",
                LineItems = new List<SessionLineItemOptions>(),
                Mode = "payment",
            };

            foreach (var item in orderVM.OOrderDetailList) {
                var sessionLineItem = new SessionLineItemOptions {
                    PriceData = new SessionLineItemPriceDataOptions {
                        UnitAmount = (long)(item.Price * 100), // $20.50 => 2050
                        Currency = "usd",
                        ProductData = new SessionLineItemPriceDataProductDataOptions {
                            Name = item.BookProduct.Title
                        }
                    },
                    Quantity = item.Quantity
                };
                options.LineItems.Add(sessionLineItem);
            }


            var service = new SessionService();
            Session session = service.Create(options);
            _unitOfWork.OrderHeader.UpdateStripePaymentId(orderVM.OrderHeader.Id, session.Id, session.PaymentIntentId);
            _unitOfWork.Save();
            Response.Headers.Add("Location", session.Url);
        }
        return new StatusCodeResult(303);
    }

    public IActionResult PaymentConfirmation(int orderHeaderId)
    {

        OrderHeader orderHeader = _unitOfWork.OrderHeader.Get(u => u.Id == orderHeaderId);

        if (orderHeader.PaymentStatus == SD.PaymentStatusDelayedPayment)
        {
            //this is an order by company

            var service = new SessionService();
            Session session = service.Get(orderHeader.SessionId);

            if (session.PaymentStatus.ToLower() == "paid") {
                _unitOfWork.OrderHeader.UpdateStripePaymentId(orderHeaderId, session.Id, session.PaymentIntentId);
                _unitOfWork.OrderHeader.UpdateStatus(orderHeaderId, orderHeader.OrderStatus, SD.PaymentStatusApproved);
                _unitOfWork.Save();
            }
        }

        return View(orderHeaderId);
    }

    [Authorize(Roles = SD.Role_Admin + "," + SD.Role_Employee)]
    [HttpPost]
    public IActionResult StartProcessing()
    {
        _unitOfWork.OrderHeader.UpdateStatus(orderVM.OrderHeader.Id, SD.StatusInProcess);
        _unitOfWork.Save();

        TempData["Success"] = "Order Details Updated Successfully";

        return RedirectToAction(nameof(Details), new { orderId = orderVM.OrderHeader.Id });
    }


    [Authorize(Roles = SD.Role_Admin + "," + SD.Role_Employee)]
    [HttpPost]
    public IActionResult ShipOrder()
    {
        OrderHeader outputOrderHeader = new OrderHeader();

        if (orderVM?.OrderHeader is not null)
        {
            var oh = _unitOfWork.OrderHeader.Get(o => o.Id == orderVM.OrderHeader.Id);
            oh.TrackingNumber = orderVM.OrderHeader.TrackingNumber;
            oh.Carrier = orderVM.OrderHeader.Carrier;
            oh.OrderStatus = SD.StatusShipped;
            oh.ShippingDate = DateTime.UtcNow;

            if (oh.PaymentStatus == SD. PaymentStatusDelayedPayment)
            {
                oh.PaymentDueDate = DateTime.UtcNow.AddDays(30);
            }

            outputOrderHeader = oh;
        }

        _unitOfWork.OrderHeader.Update(outputOrderHeader);
        _unitOfWork.Save();

        TempData["Success"] = "Order Shipped Successfully";

        return RedirectToAction(nameof(Details), new { orderId = orderVM.OrderHeader.Id });
    }


    [HttpPost]
    [Authorize(Roles = SD.Role_Admin + "," + SD.Role_Employee)]
    public IActionResult CancelOrder()
    {

        OrderHeader outputOrderHeader = new OrderHeader();

        if (orderVM?.OrderHeader is not null)
        {
            var orderHeader = _unitOfWork.OrderHeader.Get(u => u.Id == orderVM.OrderHeader.Id);

            if (orderHeader.PaymentStatus == SD.PaymentStatusApproved) {
                var options = new RefundCreateOptions {
                    Reason = RefundReasons.RequestedByCustomer,
                    PaymentIntent = orderHeader.PaymentIntentId
                };

                var service = new RefundService();
                Refund refund = service.Create(options);

                _unitOfWork.OrderHeader.UpdateStatus(orderHeader.Id, SD.StatusCancelled, SD.StatusRefunded);
            }
            else {
                _unitOfWork.OrderHeader.UpdateStatus(orderHeader.Id, SD.StatusCancelled, SD.StatusCancelled);
            }
            _unitOfWork.Save();
            outputOrderHeader = orderHeader;
        }
        TempData["Success"] = "Order Cancelled Successfully.";
        return RedirectToAction(nameof(Details), new { orderId = outputOrderHeader.Id });

    }


    #region API CALLS

    [HttpGet]
    public IActionResult GetAll(string status)
    {

        IEnumerable<OrderHeader> O_OrderHeaders;


        if (User.IsInRole(SD.Role_Admin) || User.IsInRole(SD.Role_Employee))
        {
            O_OrderHeaders = _unitOfWork.OrderHeader.GetAll(includeProperties:"ApplicationUser").ToList();
        }
        else
        {
            var claimsIdentity = (ClaimsIdentity)User.Identity;
            var claim_userId = claimsIdentity.FindFirst(ClaimTypes.NameIdentifier).Value;

            O_OrderHeaders = _unitOfWork.OrderHeader.GetAll(u => u.ApplicationUserId == claim_userId, includeProperties: "ApplicationUser");
        }


        switch (status) {
            case "pending":
                O_OrderHeaders = O_OrderHeaders.Where(u => u.PaymentStatus == SD.PaymentStatusPending);
                break;
            case "inprocess":
                O_OrderHeaders = O_OrderHeaders.Where(u => u.OrderStatus == SD.StatusInProcess);
                break;
            case "completed":
                O_OrderHeaders = O_OrderHeaders.Where(u => u.OrderStatus == SD.StatusShipped);
                break;
            case "approved":
                O_OrderHeaders = O_OrderHeaders.Where(u => u.OrderStatus == SD.StatusApproved);
                break;
            default:
                break;
        }

        return Json(
            new {
                data = O_OrderHeaders
            }
        );
    }

    #endregion
}

BulkyWeb/Areas/Admin/Controllers/UserController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Bulky.Models;
using Bulky.Models.ViewModels;
using Bulky.DataAccess.Repository.IRepository;
using Bulky.DataAccess.Data;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.EntityFrameworkCore;
using System.Collections.Generic;
using System.Data;
using Bulky.Utils;

namespace BulkyWeb.Areas.Admin.Controllers;

[Area("Admin")]
// [Authorize(Roles = SD.Role_Admin)]
public class UserController : Controller
{
    private readonly IUnitOfWork? _unitOfWork;
    private readonly ApplicationDbContext? _db;
    private readonly UserManager<IdentityUser> _userManager;
    private readonly RoleManager<IdentityRole> _roleManager;

    public UserController(
        ApplicationDbContext db, 
        IUnitOfWork unitOfWork,
        UserManager<IdentityUser> userManager,
        RoleManager<IdentityRole> roleManager
    )
    {
        _unitOfWork = unitOfWork;
        _db = db;
        _roleManager = roleManager;
        _userManager = userManager;
    }

    public IActionResult Index()
    {
        return View();
    }

    public IActionResult RoleManagement(string userId) {

        var roleId = _db?.UserRoles?.FirstOrDefault(u => u.UserId == userId).RoleId;

        RoleManagementVM roleVM = new RoleManagementVM() {
            ApplicationUser = _unitOfWork.ApplicationUser.Get(u => u.Id == userId, includeProperties:"Company"),
            RoleList = _roleManager.Roles.Select(i => new SelectListItem {
                Text = i.Name,
                Value = i.Name
            }),
            CompanyList = _unitOfWork.Company.GetAll().Select(i => new SelectListItem {
                Text = i.Name,
                Value = i.Id.ToString()
            }),
        };

        roleVM.ApplicationUser.Role = _userManager.GetRolesAsync(_unitOfWork.ApplicationUser.Get(u=>u.Id==userId))
                .GetAwaiter().GetResult().FirstOrDefault();
        return View(roleVM);
    }
    [HttpPost]
    public IActionResult RoleManagement(RoleManagementVM roleManagementVM) 
    {
        var roleId = _db?.UserRoles?.FirstOrDefault(u => u.UserId == roleManagementVM.ApplicationUser.Id).RoleId;
        string oldRole  = _userManager.GetRolesAsync(_unitOfWork.ApplicationUser.Get(
            u => u.Id == roleManagementVM.ApplicationUser.Id)).GetAwaiter().GetResult().FirstOrDefault();

        ApplicationUser applicationUser = _unitOfWork.ApplicationUser.Get(u => u.Id == roleManagementVM.ApplicationUser.Id);

        if (!(roleManagementVM.ApplicationUser?.Role == oldRole)) {
            //a role was updated            

            if (roleManagementVM.ApplicationUser?.Role == SD.Role_Company) {
                applicationUser.CompanyId = roleManagementVM.ApplicationUser.CompanyId;
            }
            if (oldRole == SD.Role_Company) {
                applicationUser.CompanyId = null;
            }            

            _unitOfWork.ApplicationUser.Update(applicationUser);
            _unitOfWork.Save();

            _userManager.RemoveFromRoleAsync(applicationUser, oldRole).GetAwaiter().GetResult();
            _userManager.AddToRoleAsync(applicationUser, roleManagementVM.ApplicationUser?.Role).GetAwaiter().GetResult();

        }
        else {
            if(oldRole==SD.Role_Company && applicationUser.CompanyId != roleManagementVM.ApplicationUser?.CompanyId) {
                applicationUser.CompanyId = roleManagementVM.ApplicationUser?.CompanyId;
                _unitOfWork.ApplicationUser.Update(applicationUser);
                _unitOfWork.Save();
            }
        }

        return RedirectToAction("Index");
    }


    #region API CALLS

    [HttpGet]
    public IActionResult GetAll()
    {
        IEnumerable<ApplicationUser> outputUser = new List<ApplicationUser>();
        if (_unitOfWork is not null && _db is not null)
        {
            List<ApplicationUser> O_User = _unitOfWork.ApplicationUser.GetAll(includeProperties:"Company").ToList();

            var userRoles = _db.UserRoles.ToList();
            var roles = _db.Roles.ToList();

            foreach(var user in O_User) {                

                var roleId = userRoles.FirstOrDefault(u => u.UserId == user.Id).RoleId;
                //user.Role = roles.FirstOrDefault(u => u.Id == roleId).Name;

                if (user.Company == null) {
                    user.Company = new Company() {
                        Name = ""
                    };
                }
            }
            outputUser = O_User;
        }

        return Json(
            new {
                data = outputUser
            }
        );
    }

    [HttpPost]
    public IActionResult LockUnlock([FromBody]string id)
    {
        if (id is not null)
        {
            var objFromDb = _db.ApplicationUsers.FirstOrDefault(u => u.Id == id);

            if( objFromDb is null )
            {
                return Json( new { success = false, message = "Error while locking/unlocking" } );
            }

            if ( objFromDb.LockoutEnd is not null && objFromDb.LockoutEnd > DateTime.UtcNow)
            {
                // User is currently locked and we need to unlock them
                objFromDb.LockoutEnd = DateTime.UtcNow;
            }
            else
            {
                objFromDb.LockoutEnd = DateTime.UtcNow.AddYears(1000);
            }

            _db.SaveChanges();



        }

        return Json(
                new {
                    success = true,
                    message = "Deleted successfully"
                });
        // return Json(
        //     new {
        //         success = false,
        //         message = "You have not provide a valid book product id"
        //     });
    }

    #endregion
}

BulkyWeb/ViewComponents/ShoppingCartViewComponent.cs
using System.Security.Claims;
using Microsoft.AspNetCore.Authorization;
using Bulky.Utils;
using Microsoft.AspNetCore.Mvc;
using Bulky.DataAccess.Repository.IRepository;

namespace BulkyWeb.ViewComponents
{
    public class ShoppingCartViewComponent : ViewComponent
    {
        private readonly IUnitOfWork _unitOfWork;

        public ShoppingCartViewComponent(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        public async Task<IViewComponentResult> InvokeAsync()
        {
            var claimsIdentity = (ClaimsIdentity)User.Identity;
            var userId = claimsIdentity.FindFirst(ClaimTypes.NameIdentifier);

            if(userId is not null)
            {
                if(HttpContext.Session.GetInt32(SD.SessionCart) is null)
                {
                    HttpContext.Session.SetInt32(SD.SessionCart,
                            _unitOfWork.Cart.GetAll(u => u.ApplicationUserId == userId.Value).Count());
                }

                return View(HttpContext.Session.GetInt32(SD.SessionCart));
            }
            else
            {
                HttpContext.Session.Clear();
                return View(0);
            }
        }
    }
}

BulkyWeb/Views/Shared/_Layout.cshtml
@using Bulky.Utils
@using Microsoft.AspNetCore.Http
@inject IHttpContextAccessor HttpContextAccessor

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - BulkyBookWeb</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/BulkyWeb.styles.css" asp-append-version="true" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.3/font/bootstrap-icons.css">
    <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/css/toastr.min.css" />

    <link rel="stylesheet" href="//cdn.datatables.net/1.13.5/css/jquery.dataTables.min.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-dark bg-primary border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">
                    <img src="/images/book.png" style="width:30px" />
                </a>
                <!-- <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                     aria-expanded="false" aria-label="Toggle navigation">
                     </button> -->
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav me-auto">
                     <span class="navbar-toggler-icon"></span>
                        <li class="nav-item">
                            <a class="nav-link" asp-area="Customer" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        @if (User.IsInRole(SD.Role_Admin) || User.IsInRole(SD.Role_Company) || User.IsInRole(SD.Role_Customer)){
                            <li class="nav-item">
                                <a class="nav-link" asp-area="Admin" asp-controller="Order" asp-action="Index">Order Management</a>
                            </li>
                        }
                        @if (User.IsInRole(SD.Role_Admin)){
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                                    Content Management
                                </a>
                                <ul class="dropdown-menu">
                                    <li>
                                        <a class="dropdown-item" asp-area="Admin" asp-controller="Category" asp-action="Index">Categories</a>
                                    </li>
                                    <li>
                                        <a class="dropdown-item" asp-area="Admin" asp-controller="BookProduct" asp-action="Index">Book List</a>
                                    </li>
                                    <li>
                                        <a class="dropdown-item" asp-area="Admin" asp-controller="Company" asp-action="Index">Company List</a>
                                    </li>
                                    <li><hr class="dropdown-divider"></li>
                                    <li>
                                        <a class="dropdown-item" asp-area="Identity" asp-page="/Account/Register">Create User</a>
                                    </li>
                                    <li>
                                        <a class="dropdown-item" asp-area="Admin" asp-controller="User" asp-action="Index">Manage Users</a>
                                    </li>
                                </ul>
                            </li>
                        }

                                <li class="nav-item">
                                    <a class="nav-link" asp-area="Customer" asp-controller="Cart" asp-action="Index">
                                        @await Component.InvokeAsync("ShoppingCart")
                                    </a>
                                </li>

                    </ul>
                    <partial name="_LoginPartial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container-lg">
        <main class="pb-3">
            <partial name="_Notification" />
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer bg-primary text-muted">
        <div class="text-center">
            Made with <i class="bi bi-heart-fill"></i> by DotNetMastery
        </div>
    </footer>

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>
    <script src="//cdn.datatables.net/1.13.5/js/jquery.dataTables.min.js" asp-append-version="true"></script>

    <script src="https://cdn.tiny.cloud/1/rvvn8q1ptl273r9i0g6sdz2sb4fmiod0l0z3ro9cv9ko5qpf/tinymce/6/tinymce.min.js" referrerpolicy="origin">
        <script src="~/lib/jquery/dist/jquery.min.js"></script>

    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>
    @await RenderSectionAsync("Scripts", required: false)

</body>

</html>

BulkyWeb/Views/Shared/_Notification.cshtml
@if (TempData["success"] != null)
{
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>

    <script type="text/javascript">
         toastr.success('@TempData["success"]');
    </script>
}

@if (TempData["error"] != null)
{
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>

    <script type="text/javascript">
         toastr.error('@TempData["error"]');
    </script>
}